<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;

class Permission
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next,$param = "")
    {
        $condition = (isClient() && $param == "client") || (isAdmin() && $param == "admin") || isEmployee();

        if($condition){
            if(isEmployee() && !isPermitted()){
                return redirect(route('get.clients'))->withErrors(["message"=>"You don't have permission on the page."]);
            }
            return $next($request);
        }

        return back()->withErrors(["message"=>"You don't have permission on the page."]);
    }
}
